<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/thread/lowpan.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('de/d66/lowpan_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">lowpan.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../de/d66/lowpan_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef LOWPAN_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define LOWPAN_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d5/d8c/message_8hpp.html">common/message.hpp</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/d97/mac__frame_8hpp.html">mac/mac_frame.hpp</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/dd4/ip6_8hpp.html">net/ip6.hpp</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/d02/ip6__address_8hpp.html">net/ip6_address.hpp</a>&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">class </span>ThreadNetif;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="../../d2/d3b/namespaceThread_1_1NetworkData.html">   46</a></span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d2/d66/classThread_1_1NetworkData_1_1NetworkData.html">NetworkData</a> { <span class="keyword">class </span><a class="code" href="../../d6/d9b/classThread_1_1NetworkData_1_1Leader.html">Leader</a>; }</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">namespace </span>Lowpan {</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">   70</a></span>&#160;<span class="keyword">struct </span><a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">Context</a></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;{</div><div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a066532d36c55024cf1eada6ad5ea4ce9">   72</a></span>&#160;    <span class="keyword">const</span> uint8_t *<a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a066532d36c55024cf1eada6ad5ea4ce9">mPrefix</a>;        </div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a12f4443adbe7452481f8d9499b9457ef">   73</a></span>&#160;    uint8_t        <a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a12f4443adbe7452481f8d9499b9457ef">mPrefixLength</a>;  </div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a73dc096e3d90d37f5682232799b59569">   74</a></span>&#160;    uint8_t        <a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a73dc096e3d90d37f5682232799b59569">mContextId</a>;     </div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;};</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html">   81</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html">Lowpan</a></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;{</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    {</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        kHopsLeft = 14,</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    };</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keyword">explicit</span> <a class="code" href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html">Lowpan</a>(<a class="code" href="../../d3/d8e/classThread_1_1ThreadNetif.html">ThreadNetif</a> &amp;aThreadNetif);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html#ade9d72685760a1b3901c72b9a798f057">  105</a></span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html#ade9d72685760a1b3901c72b9a798f057">IsLowpanHc</a>(uint8_t *aHeader) {</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="keywordflow">return</span> (aHeader[0] &amp; (Lowpan::kHcDispatchMask &gt;&gt; 8)) == (Lowpan::kHcDispatch &gt;&gt; 8);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordtype">int</span> Compress(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacSource, <span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacDest, uint8_t *aBuf);</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordtype">int</span> Decompress(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, <span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacSource, <span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacDest,</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;                   <span class="keyword">const</span> uint8_t *aBuf, uint16_t aBufLen, uint16_t aDatagramLen);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="keywordtype">int</span> DecompressBaseHeader(<a class="code" href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html">Ip6::Header</a> &amp;aHeader, <span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacSource, <span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacDest,</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                             <span class="keyword">const</span> uint8_t *aBuf);</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        kHcDispatch        = 3 &lt;&lt; 13,</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        kHcDispatchMask    = 7 &lt;&lt; 13,</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        kHcTrafficClass    = 1 &lt;&lt; 11,</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        kHcFlowLabel       = 2 &lt;&lt; 11,</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        kHcTrafficFlow     = 3 &lt;&lt; 11,</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        kHcTrafficFlowMask = 3 &lt;&lt; 11,</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        kHcNextHeader      = 1 &lt;&lt; 10,</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        kHcHopLimit1       = 1 &lt;&lt; 8,</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        kHcHopLimit64      = 2 &lt;&lt; 8,</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        kHcHopLimit255     = 3 &lt;&lt; 8,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        kHcHopLimitMask    = 3 &lt;&lt; 8,</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        kHcContextId       = 1 &lt;&lt; 7,</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        kHcSrcAddrContext  = 1 &lt;&lt; 6,</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        kHcSrcAddrMode0    = 0 &lt;&lt; 4,</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        kHcSrcAddrMode1    = 1 &lt;&lt; 4,</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        kHcSrcAddrMode2    = 2 &lt;&lt; 4,</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        kHcSrcAddrMode3    = 3 &lt;&lt; 4,</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        kHcSrcAddrModeMask = 3 &lt;&lt; 4,</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        kHcMulticast       = 1 &lt;&lt; 3,</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        kHcDstAddrContext  = 1 &lt;&lt; 2,</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        kHcDstAddrMode0    = 0 &lt;&lt; 0,</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        kHcDstAddrMode1    = 1 &lt;&lt; 0,</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        kHcDstAddrMode2    = 2 &lt;&lt; 0,</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        kHcDstAddrMode3    = 3 &lt;&lt; 0,</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        kHcDstAddrModeMask = 3 &lt;&lt; 0,</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        kExtHdrDispatch     = 0xe0,</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        kExtHdrDispatchMask = 0xf0,</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        kExtHdrEidHbh       = 0x00,</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        kExtHdrEidRouting   = 0x02,</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        kExtHdrEidFragment  = 0x04,</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        kExtHdrEidDst       = 0x06,</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        kExtHdrEidMobility  = 0x08,</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        kExtHdrEidIp6       = 0x0e,</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        kExtHdrEidMask      = 0x0e,</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        kExtHdrNextHeader   = 0x01,</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        kUdpDispatch        = 0xf0,</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        kUdpDispatchMask    = 0xf8,</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        kUdpChecksum        = 1 &lt;&lt; 2,</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        kUdpPortMask        = 3 &lt;&lt; 0,</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    };</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <span class="keywordtype">int</span> CompressExtensionHeader(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;message, uint8_t *aBuf, uint8_t &amp;nextHeader);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordtype">int</span> CompressSourceIid(<span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;macaddr, <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;ipaddr, <span class="keyword">const</span> <a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">Context</a> &amp;aContext,</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;                          uint16_t &amp;hcCtl, uint8_t *aBuf);</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keywordtype">int</span> CompressDestinationIid(<span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;macaddr, <span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;ipaddr, <span class="keyword">const</span> <a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">Context</a> &amp;aContext,</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                               uint16_t &amp;hcCtl, uint8_t *aBuf);</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordtype">int</span> CompressMulticast(<span class="keyword">const</span> <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;ipaddr, uint16_t &amp;hcCtl, uint8_t *aBuf);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <span class="keywordtype">int</span> CompressUdp(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;message, uint8_t *aBuf);</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="keywordtype">int</span> DecompressExtensionHeader(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;message, <span class="keyword">const</span> uint8_t *aBuf, uint16_t aBufLength);</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <span class="keywordtype">int</span> DecompressUdpHeader(<a class="code" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;message, <span class="keyword">const</span> uint8_t *aBuf, uint16_t aBufLength, uint16_t datagramLength);</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> DispatchToNextHeader(uint8_t dispatch, <a class="code" href="../../d9/dcf/group__core-ip6-ip6.html#ga83d94b02a618038e1534f9e12001d095">Ip6::IpProto</a> &amp;nextHeader);</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keyword">static</span> <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> CopyContext(<span class="keyword">const</span> <a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">Context</a> &amp;aContext, <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aAddress);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keyword">static</span> <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> ComputeIid(<span class="keyword">const</span> <a class="code" href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Mac::Address</a> &amp;aMacAddr, <span class="keyword">const</span> <a class="code" href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">Context</a> &amp;aContext, <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> &amp;aIpAddress);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <a class="code" href="../../d6/d9b/classThread_1_1NetworkData_1_1Leader.html">NetworkData::Leader</a> &amp;mNetworkData;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;};</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<a class="code" href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="line"><a name="l00224"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html">  224</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html">MeshHeader</a></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;{</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00231"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac9badbc6741e168e46e6892657773a38">  231</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac9badbc6741e168e46e6892657773a38">Init</a>() { mDispatchHopsLeft = kDispatch | kSourceShort | kDestinationShort; }</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac482fb1bed52a29164b199ac1a54715d">  240</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac482fb1bed52a29164b199ac1a54715d">IsMeshHeader</a>() { <span class="keywordflow">return</span> (mDispatchHopsLeft &amp; kDispatchMask) == kDispatch; }</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#aca669774393e548cff16e290780b9d33">  249</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#aca669774393e548cff16e290780b9d33">IsValid</a>() { <span class="keywordflow">return</span> (mDispatchHopsLeft &amp; kSourceShort) &amp;&amp; (mDispatchHopsLeft &amp; kDestinationShort); }</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ae65701e6d34abd28e66332395bd95430">  257</a></span>&#160;    <span class="keyword">static</span> uint8_t <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ae65701e6d34abd28e66332395bd95430">GetHeaderLength</a>() { <span class="keywordflow">return</span> <span class="keyword">sizeof</span>(<a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html">MeshHeader</a>); }</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00265"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#abeec141e1ac19ad0fb6dde601b650dce">  265</a></span>&#160;    uint8_t <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#abeec141e1ac19ad0fb6dde601b650dce">GetHopsLeft</a>() { <span class="keywordflow">return</span> mDispatchHopsLeft &amp; kHopsLeftMask; }</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac29f926f9297f350791d94dc4022e403">  273</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac29f926f9297f350791d94dc4022e403">SetHopsLeft</a>(uint8_t aHops) { mDispatchHopsLeft = (mDispatchHopsLeft &amp; ~kHopsLeftMask) | aHops; }</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ad199618dbd207c048d8320525e73be83">  281</a></span>&#160;    uint16_t <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ad199618dbd207c048d8320525e73be83">GetSource</a>() { <span class="keywordflow">return</span> HostSwap16(mSource); }</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#a268b60c4d5997dd05aff591441a37f1f">  289</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#a268b60c4d5997dd05aff591441a37f1f">SetSource</a>(uint16_t aSource) { mSource = HostSwap16(aSource); }</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#a7e1ec6692cd44d3e53c4d9fb75b82297">  297</a></span>&#160;    uint16_t <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#a7e1ec6692cd44d3e53c4d9fb75b82297">GetDestination</a>() { <span class="keywordflow">return</span> HostSwap16(mDestination); }</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno"><a class="line" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ad6cd2f99750a7c8fd4613608155a1587">  305</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ad6cd2f99750a7c8fd4613608155a1587">SetDestination</a>(uint16_t aDestination) { mDestination = HostSwap16(aDestination); }</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    {</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        kDispatch         = 2 &lt;&lt; 6,</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        kDispatchMask     = 3 &lt;&lt; 6,</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        kHopsLeftMask     = 0xf &lt;&lt; 0,</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        kSourceShort      = 1 &lt;&lt; 5,</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        kDestinationShort = 1 &lt;&lt; 4,</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    };</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    uint8_t mDispatchHopsLeft;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    uint16_t mSource;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    uint16_t mDestination;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;} <a class="code" href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a>;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;<a class="code" href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="line"><a name="l00327"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html">  327</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html">FragmentHeader</a></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;{</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00334"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a53e634d188c7fac0acf4fce06a3ac112">  334</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a53e634d188c7fac0acf4fce06a3ac112">Init</a>() { mDispatchOffsetSize = kDispatch; }</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div><div class="line"><a name="l00343"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#af549d79b0e52a6df7165998c9005dff4">  343</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#af549d79b0e52a6df7165998c9005dff4">IsFragmentHeader</a>() { <span class="keywordflow">return</span> (mDispatchOffsetSize &amp; kDispatchMask) == kDispatch; }</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;</div><div class="line"><a name="l00351"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a8c1dceb257aa41c7e7ab2fbb78a71a8d">  351</a></span>&#160;    uint8_t <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a8c1dceb257aa41c7e7ab2fbb78a71a8d">GetHeaderLength</a>() {</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        <span class="keywordflow">return</span> (mDispatchOffsetSize &amp; kOffset) ? <span class="keyword">sizeof</span>(*this) : <span class="keyword">sizeof</span>(*this) - <span class="keyword">sizeof</span>(mOffset);</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;</div><div class="line"><a name="l00361"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a7055cf2380206a8dfe3122abb55800b2">  361</a></span>&#160;    uint16_t <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a7055cf2380206a8dfe3122abb55800b2">GetDatagramSize</a>() { <span class="keywordflow">return</span> HostSwap16(mSize) &amp; kSizeMask; }</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#ab67b3f90ee08487aafc07d9d16e22faf">  369</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#ab67b3f90ee08487aafc07d9d16e22faf">SetDatagramSize</a>(uint16_t aSize) {</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        mSize = HostSwap16((HostSwap16(mSize) &amp; ~kSizeMask) | (aSize &amp; kSizeMask));</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;    }</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;</div><div class="line"><a name="l00379"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a9cfcd18bb18b6c0503a6cfab64a243f2">  379</a></span>&#160;    uint16_t <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a9cfcd18bb18b6c0503a6cfab64a243f2">GetDatagramTag</a>() { <span class="keywordflow">return</span> HostSwap16(mTag); }</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#aa4e6352b87237d86690db4f04b80b451">  387</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#aa4e6352b87237d86690db4f04b80b451">SetDatagramTag</a>(uint16_t aTag) { mTag = HostSwap16(aTag); }</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00395"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a865bf2eb1518af2540ebe06f49693c65">  395</a></span>&#160;    uint16_t <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a865bf2eb1518af2540ebe06f49693c65">GetDatagramOffset</a>() { <span class="keywordflow">return</span> (mDispatchOffsetSize &amp; kOffset) ? <span class="keyword">static_cast&lt;</span>uint16_t<span class="keyword">&gt;</span>(mOffset) * 8 : 0; }</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00403"></a><span class="lineno"><a class="line" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a9dff0427986ba1acfc5ed3c8d10710fe">  403</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a9dff0427986ba1acfc5ed3c8d10710fe">SetDatagramOffset</a>(uint16_t aOffset) {</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;        <span class="keywordflow">if</span> (aOffset == 0) {</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;            mDispatchOffsetSize &amp;= ~kOffset;</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;        }</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        <span class="keywordflow">else</span> {</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;            mDispatchOffsetSize |= kOffset;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;            mOffset = (aOffset &gt;&gt; 3) &amp; kOffsetMask;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        }</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    }</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    {</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;        kDispatch     = 3 &lt;&lt; 6,</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        kDispatchMask = 3 &lt;&lt; 6,</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;        kOffset       = 1 &lt;&lt; 5,</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;        kSizeMask     = 0x7ff,</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        kOffsetMask   = 0xff,</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;    };</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    <span class="keyword">union</span></div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;    {</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;        uint8_t mDispatchOffsetSize;</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        uint16_t mSize;</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;    } <a class="code" href="../../d7/da1/group__toolchain.html#ga3a18bfefd8517f5653568f3b8423ed40">OT_TOOL_PACKED_FIELD</a>;</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    uint16_t mTag;</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;    uint8_t mOffset;</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;} <a class="code" href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a>;</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;}  <span class="comment">// namespace Lowpan</span></div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;<span class="preprocessor">#endif  // LOWPAN_HPP_</span></div><div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_aa4e6352b87237d86690db4f04b80b451"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#aa4e6352b87237d86690db4f04b80b451">Thread::Lowpan::FragmentHeader::SetDatagramTag</a></div><div class="ttdeci">void SetDatagramTag(uint16_t aTag)</div><div class="ttdoc">This method sets the Datagram Tag value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:387</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_aca669774393e548cff16e290780b9d33"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#aca669774393e548cff16e290780b9d33">Thread::Lowpan::MeshHeader::IsValid</a></div><div class="ttdeci">bool IsValid()</div><div class="ttdoc">This method indicates whether or not the Mesh Header appears to be well-formed. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:249</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_a8c1dceb257aa41c7e7ab2fbb78a71a8d"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a8c1dceb257aa41c7e7ab2fbb78a71a8d">Thread::Lowpan::FragmentHeader::GetHeaderLength</a></div><div class="ttdeci">uint8_t GetHeaderLength()</div><div class="ttdoc">This method returns the Fragment Header length. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:351</div></div>
<div class="ttc" id="structThread_1_1Lowpan_1_1Context_html_a066532d36c55024cf1eada6ad5ea4ce9"><div class="ttname"><a href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a066532d36c55024cf1eada6ad5ea4ce9">Thread::Lowpan::Context::mPrefix</a></div><div class="ttdeci">const uint8_t * mPrefix</div><div class="ttdoc">A pointer to the prefix. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:72</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_a865bf2eb1518af2540ebe06f49693c65"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a865bf2eb1518af2540ebe06f49693c65">Thread::Lowpan::FragmentHeader::GetDatagramOffset</a></div><div class="ttdeci">uint16_t GetDatagramOffset()</div><div class="ttdoc">This method returns the Datagram Offset value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:395</div></div>
<div class="ttc" id="group__toolchain_html_ga3a18bfefd8517f5653568f3b8423ed40"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#ga3a18bfefd8517f5653568f3b8423ed40">OT_TOOL_PACKED_FIELD</a></div><div class="ttdeci">#define OT_TOOL_PACKED_FIELD</div><div class="ttdoc">Indicate to the compiler a nested struct or union to be packed within byte packed class or struct...</div><div class="ttdef"><b>Definition:</b> toolchain.h:130</div></div>
<div class="ttc" id="ip6__address_8hpp_html"><div class="ttname"><a href="../../dc/d02/ip6__address_8hpp.html">ip6_address.hpp</a></div><div class="ttdoc">This file includes definitions for IPv6 addresses. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Header_html"><div class="ttname"><a href="../../d8/d6e/classThread_1_1Ip6_1_1Header.html">Thread::Ip6::Header</a></div><div class="ttdoc">This class implements IPv6 header generation and parsing. </div><div class="ttdef"><b>Definition:</b> ip6_headers.hpp:132</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_abeec141e1ac19ad0fb6dde601b650dce"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#abeec141e1ac19ad0fb6dde601b650dce">Thread::Lowpan::MeshHeader::GetHopsLeft</a></div><div class="ttdeci">uint8_t GetHopsLeft()</div><div class="ttdoc">This method returns the Hops Left value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:265</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html">Thread::Lowpan::FragmentHeader</a></div><div class="ttdoc">This class implements Fragment Header generation and parsing. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:327</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_a268b60c4d5997dd05aff591441a37f1f"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#a268b60c4d5997dd05aff591441a37f1f">Thread::Lowpan::MeshHeader::SetSource</a></div><div class="ttdeci">void SetSource(uint16_t aSource)</div><div class="ttdoc">This method sets the Mesh Source address. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:289</div></div>
<div class="ttc" id="classThread_1_1Message_html"><div class="ttname"><a href="../../dc/d3c/classThread_1_1Message.html">Thread::Message</a></div><div class="ttdoc">This class represents a message. </div><div class="ttdef"><b>Definition:</b> message.hpp:213</div></div>
<div class="ttc" id="classThread_1_1ThreadNetif_html"><div class="ttname"><a href="../../d3/d8e/classThread_1_1ThreadNetif.html">Thread::ThreadNetif</a></div><div class="ttdef"><b>Definition:</b> thread_netif.hpp:85</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_ab67b3f90ee08487aafc07d9d16e22faf"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#ab67b3f90ee08487aafc07d9d16e22faf">Thread::Lowpan::FragmentHeader::SetDatagramSize</a></div><div class="ttdeci">void SetDatagramSize(uint16_t aSize)</div><div class="ttdoc">This method sets the Datagram Size value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:369</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_a7e1ec6692cd44d3e53c4d9fb75b82297"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#a7e1ec6692cd44d3e53c4d9fb75b82297">Thread::Lowpan::MeshHeader::GetDestination</a></div><div class="ttdeci">uint16_t GetDestination()</div><div class="ttdoc">This method returns the Mesh Destination address. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:297</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_ac29f926f9297f350791d94dc4022e403"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac29f926f9297f350791d94dc4022e403">Thread::Lowpan::MeshHeader::SetHopsLeft</a></div><div class="ttdeci">void SetHopsLeft(uint8_t aHops)</div><div class="ttdoc">This method sets the Hops Left value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:273</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_a53e634d188c7fac0acf4fce06a3ac112"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a53e634d188c7fac0acf4fce06a3ac112">Thread::Lowpan::FragmentHeader::Init</a></div><div class="ttdeci">void Init()</div><div class="ttdoc">This method initializes the Fragment Header. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:334</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="classThread_1_1NetworkData_1_1NetworkData_html"><div class="ttname"><a href="../../d2/d66/classThread_1_1NetworkData_1_1NetworkData.html">Thread::NetworkData::NetworkData</a></div><div class="ttdoc">This class implements Network Data processing. </div><div class="ttdef"><b>Definition:</b> network_data.hpp:84</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_a9cfcd18bb18b6c0503a6cfab64a243f2"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a9cfcd18bb18b6c0503a6cfab64a243f2">Thread::Lowpan::FragmentHeader::GetDatagramTag</a></div><div class="ttdeci">uint16_t GetDatagramTag()</div><div class="ttdoc">This method returns the Datagram Tag value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:379</div></div>
<div class="ttc" id="classThread_1_1NetworkData_1_1Leader_html"><div class="ttname"><a href="../../d6/d9b/classThread_1_1NetworkData_1_1Leader.html">Thread::NetworkData::Leader</a></div><div class="ttdoc">This class implements the Thread Network Data maintained by the Leader. </div><div class="ttdef"><b>Definition:</b> network_data_leader.hpp:65</div></div>
<div class="ttc" id="structThread_1_1Lowpan_1_1Context_html_a12f4443adbe7452481f8d9499b9457ef"><div class="ttname"><a href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a12f4443adbe7452481f8d9499b9457ef">Thread::Lowpan::Context::mPrefixLength</a></div><div class="ttdeci">uint8_t mPrefixLength</div><div class="ttdoc">The prefix length. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:73</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html">Thread::Lowpan::MeshHeader</a></div><div class="ttdoc">This class implements Mesh Header generation and processing. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:224</div></div>
<div class="ttc" id="mac__frame_8hpp_html"><div class="ttname"><a href="../../d1/d97/mac__frame_8hpp.html">mac_frame.hpp</a></div><div class="ttdoc">This file includes definitions for generating and processing IEEE 802.15.4 MAC frames. </div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_ad6cd2f99750a7c8fd4613608155a1587"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ad6cd2f99750a7c8fd4613608155a1587">Thread::Lowpan::MeshHeader::SetDestination</a></div><div class="ttdeci">void SetDestination(uint16_t aDestination)</div><div class="ttdoc">This method sets the Mesh Destination address. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:305</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_ac9badbc6741e168e46e6892657773a38"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac9badbc6741e168e46e6892657773a38">Thread::Lowpan::MeshHeader::Init</a></div><div class="ttdeci">void Init()</div><div class="ttdoc">This method initializes the header. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:231</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_ae65701e6d34abd28e66332395bd95430"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ae65701e6d34abd28e66332395bd95430">Thread::Lowpan::MeshHeader::GetHeaderLength</a></div><div class="ttdeci">static uint8_t GetHeaderLength()</div><div class="ttdoc">This static method returns the size of the Mesh Header in bytes. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:257</div></div>
<div class="ttc" id="message_8hpp_html"><div class="ttname"><a href="../../d5/d8c/message_8hpp.html">message.hpp</a></div><div class="ttdoc">This file includes definitions for the message buffer pool and message buffers. </div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_a7055cf2380206a8dfe3122abb55800b2"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a7055cf2380206a8dfe3122abb55800b2">Thread::Lowpan::FragmentHeader::GetDatagramSize</a></div><div class="ttdeci">uint16_t GetDatagramSize()</div><div class="ttdoc">This method returns the Datagram Size value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:361</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_a9dff0427986ba1acfc5ed3c8d10710fe"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#a9dff0427986ba1acfc5ed3c8d10710fe">Thread::Lowpan::FragmentHeader::SetDatagramOffset</a></div><div class="ttdeci">void SetDatagramOffset(uint16_t aOffset)</div><div class="ttdoc">This method sets the Datagram Offset value. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:403</div></div>
<div class="ttc" id="group__core-ip6-ip6_html_ga83d94b02a618038e1534f9e12001d095"><div class="ttname"><a href="../../d9/dcf/group__core-ip6-ip6.html#ga83d94b02a618038e1534f9e12001d095">Thread::Ip6::IpProto</a></div><div class="ttdeci">IpProto</div><div class="ttdoc">Internet Protocol Numbers. </div><div class="ttdef"><b>Definition:</b> ip6_headers.hpp:89</div></div>
<div class="ttc" id="group__toolchain_html_gacf07d7a4a2ea6d0cc3426234565fcb7b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gacf07d7a4a2ea6d0cc3426234565fcb7b">OT_TOOL_PACKED_END</a></div><div class="ttdeci">#define OT_TOOL_PACKED_END</div><div class="ttdoc">Compiler-specific indication at the end of a byte packed class or struct. </div><div class="ttdef"><b>Definition:</b> toolchain.h:131</div></div>
<div class="ttc" id="structThread_1_1Mac_1_1Address_html"><div class="ttname"><a href="../../dd/dcd/structThread_1_1Mac_1_1Address.html">Thread::Mac::Address</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 Short or Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:152</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_ac482fb1bed52a29164b199ac1a54715d"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ac482fb1bed52a29164b199ac1a54715d">Thread::Lowpan::MeshHeader::IsMeshHeader</a></div><div class="ttdeci">bool IsMeshHeader()</div><div class="ttdoc">This method indicates whether or not the header is a Mesh Header. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:240</div></div>
<div class="ttc" id="ip6_8hpp_html"><div class="ttname"><a href="../../d1/dd4/ip6_8hpp.html">ip6.hpp</a></div><div class="ttdoc">This file includes definitions for IPv6 packet processing. </div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1Lowpan_html"><div class="ttname"><a href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html">Thread::Lowpan::Lowpan</a></div><div class="ttdoc">This class implements LOWPAN_IPHC header compression. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:81</div></div>
<div class="ttc" id="structThread_1_1Lowpan_1_1Context_html"><div class="ttname"><a href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html">Thread::Lowpan::Context</a></div><div class="ttdoc">This structure represents a LOWPAN_IPHC Context. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:70</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1MeshHeader_html_ad199618dbd207c048d8320525e73be83"><div class="ttname"><a href="../../db/db1/classThread_1_1Lowpan_1_1MeshHeader.html#ad199618dbd207c048d8320525e73be83">Thread::Lowpan::MeshHeader::GetSource</a></div><div class="ttdeci">uint16_t GetSource()</div><div class="ttdoc">This method returns the Mesh Source address. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:281</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1FragmentHeader_html_af549d79b0e52a6df7165998c9005dff4"><div class="ttname"><a href="../../d7/d6c/classThread_1_1Lowpan_1_1FragmentHeader.html#af549d79b0e52a6df7165998c9005dff4">Thread::Lowpan::FragmentHeader::IsFragmentHeader</a></div><div class="ttdeci">bool IsFragmentHeader()</div><div class="ttdoc">This method indicates whether or not the header is a Fragment Header. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:343</div></div>
<div class="ttc" id="classThread_1_1Lowpan_1_1Lowpan_html_ade9d72685760a1b3901c72b9a798f057"><div class="ttname"><a href="../../d8/d3a/classThread_1_1Lowpan_1_1Lowpan.html#ade9d72685760a1b3901c72b9a798f057">Thread::Lowpan::Lowpan::IsLowpanHc</a></div><div class="ttdeci">static bool IsLowpanHc(uint8_t *aHeader)</div><div class="ttdoc">This method indicates whether or not the header is a LOWPAN_IPHC header. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:105</div></div>
<div class="ttc" id="group__toolchain_html_gaba6ad63129c3a790957a9b149a65891b"><div class="ttname"><a href="../../d7/da1/group__toolchain.html#gaba6ad63129c3a790957a9b149a65891b">OT_TOOL_PACKED_BEGIN</a></div><div class="ttdeci">#define OT_TOOL_PACKED_BEGIN</div><div class="ttdoc">Compiler-specific indication that a class or struct must be byte packed. </div><div class="ttdef"><b>Definition:</b> toolchain.h:129</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="structThread_1_1Lowpan_1_1Context_html_a73dc096e3d90d37f5682232799b59569"><div class="ttname"><a href="../../dc/dcb/structThread_1_1Lowpan_1_1Context.html#a73dc096e3d90d37f5682232799b59569">Thread::Lowpan::Context::mContextId</a></div><div class="ttdeci">uint8_t mContextId</div><div class="ttdoc">The Context ID. </div><div class="ttdef"><b>Definition:</b> lowpan.hpp:74</div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_fd71accbf528c1576ca21e7ec5716833.html">thread</a></li><li class="navelem"><a class="el" href="../../de/d66/lowpan_8hpp.html">lowpan.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
